<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\Http\Controllers\AbstractPortalController;
use App\Http\Controllers\AbstractSubmissionController;
use App\Models\AbstractData;
use Illuminate\Database\Query\JoinClause;
use Session;
use Auth;
use Response;
use DB;


class AbstractPortalController extends Controller
{
    public $search_from="";
    public $search_text="";
    public $user_id="";

    public function index()
    {
        $user_id=Auth::user()->id;
        $data = DB::table('abstract_submissions')
        ->where('user_id', '=', $user_id)
        ->get();
        if(isset($data[0])){
            $recoredcount = AbstractData::where('status','=','1')->where('user_id', Auth::user()->id)->count();
            return view('abstract_portal')->with(compact('recoredcount'));
        }else{
         $returnPath="abstractPortal";
         return view('abstract_submition')->with(compact('returnPath'));
        }
    }


    public function submit(Request $request){

        $validator = Validator::make($request->all(), [
            'submission_title' => 'required|string|max:255',
            'abstract_text'=>'required',
            'author_data'=>'required',
            'presenting_author'=>'required',
            'abstract_file'=>'required',
            'ethical_clearance'=>'required',
            'clinical_trial_registered'=>'required',
            'abstract_presentation'=>'required',
            'previously_presented'=>'required'
        ]);
        if ($validator->fails()) {
            // return redirect()->back()
            //     ->withErrors($validator)
            //     ->withInput();
            return response()->json($validator->messages(), 400);
            
        }
        if((int)$request->input('word_count')>300){
            // $data = array('item' => "Your abstract text word limit exceeded");
            $data = array (array("Your abstract text word limit exceeded"));
            return response()->json($data, 400);
        }

        // set all data on session 
        Session::put('submission_title', $request->input('submission_title'));
        Session::put('authors_data', $request->input('author_data'));
        Session::put('abstract_text', $request->input('abstract_text'));
        Session::put('abstract_file', $request->input('abstract_file'));
        Session::put('approval_letter_file', $request->input('approval_letter_file'));
        Session::put('presenting_author', $request->input('presenting_author'));
        Session::put('ethical_clearance', $request->input('ethical_clearance'));
        Session::put('clinical_trial_registered', $request->input('clinical_trial_registered'));
        Session::put('abstract_presentation', $request->input('abstract_presentation'));
        Session::put('previously_presented', $request->input('previously_presented'));
        

        
        
        
        //print_r(Session::get('authors_data'));
        // return redirect('/abstractReview');
        return response()->json("ok", 200); 
    }

    public function store(Request $request,$type){
        $request->validate([
            'file' => 'required',
        ],
    [
        'file.required' => 'Please select file to upload!'
    ]);

// get current user profile data
        $result = (new AbstractSubmissionController)->get();
        $profile=json_decode($result->content(), true);

        $fileName = $profile["id"].'_'.$type.'_'.time().'.'.request()->file->getClientOriginalExtension();

        request()->file->move(public_path('files'), $fileName);

        return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);

    }
    public function get(){
        $user_id=Auth::user()->id;
        if(DB::table('abstract_submissions')->where('user_id', '=', $user_id)->where('status', '=', 1)->exists()){
            $data = DB::table('abstract_submissions')
            ->where('user_id', '=', $user_id)
            ->where('status', '=', 1)
            ->get();
            
        }else{
            return response()->json("No profile", 404); 
        }

        $user_id=Auth::user()->id;
        $data = DB::table('abstract_data')
        ->where('user_id', '=', $user_id)
        ->where('status', '=', 1)
        ->get();
        if(isset($data)){
            return Response::json($data);
        }else{
            return response()->json("No data", 404); 
        }
    }
    public function getAuthors(Request $request,$id){
        $abstract_id=$id;
        $data = DB::table('abstract_authors')
        ->where('abstract_data_id', '=', $abstract_id)
        ->where('status', '=', 1)
        ->get();
        if(isset($data)){
            return Response::json($data);
        }else{
            return response()->json("No data", 404); 
        }
    }
    public function getAbstractAuthors($id){
        $abstract_id=$id;
        $data = DB::table('abstract_authors')
        ->where('abstract_data_id', '=', $abstract_id)
        ->where('status', '=', 1)
        ->select('abstract_authors.author_name','abstract_authors.author_affiliation','abstract_authors.author_email')
        ->get();
        if(isset($data)){
            //return Response::json($data);
            return $data;
        }else{
            return false; 
        }
    }
    

    public function getAbstract(Request $request,$user_id){
        $user_id=$user_id;
        
        $data = DB::table('abstract_data')
        ->where('user_id', '=', $user_id)
        ->where('status', '=', 1)
        ->get();

        if(isset($data)){
            return view('admin_abstract_list')->with(compact('data'));
        }else{
            return response()->json("No data", 404); 
        }
    }

    public function getFullAbstract(Request $request,$abstract_id){
        $abstract_id=$abstract_id;
        
        $ab_data = DB::table('abstract_data')
        ->where('id', '=', $abstract_id)
        ->where('status', '=', 1)
        ->get();

        $au_data = DB::table('abstract_authors')
        ->where('abstract_data_id', '=', $abstract_id)
        ->where('status', '=', 1)
        ->get();
        // $data = [
        //     'ab_data' => $ab_data,
        //     'au_data' => $au_data
        // ];

        if(isset($ab_data)){
            return view('admin_abstract_full')->with(compact('ab_data','au_data'));
        }else{
            return response()->json("No data", 404); 
        }

    }

    public function getUserAbstract(Request $request,$abstract_id){
        $abstract_id=$abstract_id;
        $user_id=Auth::user()->id;
        
        $ab_data = DB::table('abstract_data')
        ->where('user_id', '=', $user_id)
        ->where('id', '=', $abstract_id)
        ->where('status', '=', 1)
        ->get();

        $au_data = DB::table('abstract_authors')
        ->where('abstract_data_id', '=', $abstract_id)
        ->where('status', '=', 1)
        ->get();
        // $data = [
        //     'ab_data' => $ab_data,
        //     'au_data' => $au_data
        // ];

        if(isset($ab_data)){
            return view('dashboard-abstract-full')->with(compact('ab_data','au_data'));
        }else{
            return response()->json("No data", 404); 
        }

    }

    public function getUserAbstracts(Request $request){
        $this->user_id=Auth::user()->id;
        $data=DB::table('abstract_data')
        ->join('abstract_submissions', function (JoinClause $join) {
            $join->on('abstract_data.user_id', '=', 'abstract_submissions.user_id')
            ->where('abstract_data.user_id', '=',$this->user_id);
        })
        ->select('abstract_data.id','abstract_data.abstract_title','abstract_data.abstract_file','abstract_data.ethical_clearance', 'abstract_submissions.given_name','abstract_submissions.surname','abstract_submissions.id AS sub_id')
        ->orderBy('abstract_data.id', 'desc')
        ->get();
        if(isset($data)){
            return Response::json($data);
        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }
    }

    public function getAllAbstracts(Request $request){
        $this->search_text=$request->input('search_text');
        $this->search_from=$request->input('search_from');
        $data=DB::table('abstract_data')
        ->join('abstract_submissions', function (JoinClause $join) {
            $join->on('abstract_data.user_id', '=', 'abstract_submissions.user_id');
            
        })
        ->select('abstract_data.id','abstract_data.abstract_title','abstract_data.abstract_file','abstract_data.ethical_clearance', 'abstract_submissions.given_name','abstract_submissions.surname','abstract_submissions.id AS sub_id')
        ->orderBy('abstract_data.id', 'desc')
        ->get();
        if(isset($data)){
            return Response::json($data);
        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }
    }
    public function getAllAbstractsSearch(Request $request){
        $this->search_text=$request->input('search_text');
        $this->search_from=$request->input('search_from');
        if($this->search_from=='id'){
            if(preg_match("/[a-z]/i", $this->search_text)){
                $this->search_text = preg_replace("/[^0-9]/", "", $request->input('search_text') );
            }
        }
        $data=DB::table('abstract_data')
        ->join('abstract_submissions', function (JoinClause $join) {
            $join->on('abstract_data.user_id', '=', 'abstract_submissions.user_id')
            ->where('abstract_data.'.$this->search_from, 'like',  '%'.$this->search_text.'%');
            
        })
        ->select('abstract_data.id','abstract_data.abstract_title','abstract_data.abstract_file','abstract_data.ethical_clearance', 'abstract_submissions.given_name','abstract_submissions.surname','abstract_submissions.id AS sub_id')
        ->orderBy('abstract_data.id', 'desc')
        ->get();
        if(isset($data)){
          return Response::json($data);
        // $jsonFile = $data;
        // $csvFile = public_path('files/animals.csv');
        // $this->convertJsonToCSV($jsonFile, $csvFile);

        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }
    }

    public function getAbstractCsv(Request $request){
        $this->search_text=$request->input('search_text');
        $this->search_from=$request->input('search_from');
        if($this->search_from=='id'){
            if(preg_match("/[a-z]/i", $this->search_text)){
                $this->search_text = preg_replace("/[^0-9]/", "", $request->input('search_text') );
            }
        }
        $data=DB::table('abstract_data')
        ->join('abstract_submissions', function (JoinClause $join) {
            $join->on('abstract_data.user_id', '=', 'abstract_submissions.user_id')
            ->where('abstract_data.'.$this->search_from, 'like',  '%'.$this->search_text.'%');
            
        })
        ->select('abstract_data.id','abstract_submissions.given_name','abstract_data.abstract_title','abstract_data.presenting_author','abstract_data.abstract_text','abstract_data.abstract_file','abstract_data.ethical_clearance','abstract_data.approval_letter_file','abstract_data.clinical_trial_registered','abstract_data.abstract_presentation','abstract_data.previously_presented','abstract_data.created_at')
        ->get();
        if(isset($data)){
            //return Response::json($data);
        $jsonFile = $data;
        $csvFile = public_path('files/abstract_reports/abstracts.csv');
        $this->convertJsonToCSV($jsonFile, $csvFile);
        return response()->json("Success", 200); 
        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }    
    }

    public function convertJsonToCSV($jsonFile, $csvFile){
        // if (($json = file_get_contents($jsonFile)) == false) {
        //     die('Unable to read JSON file.');
        // }
        $jsonString = json_decode($jsonFile, true);
        $fp = fopen($csvFile, 'w');
        
        //fputcsv($fp, array_keys($jsonString[0]));
        $head=array("Id","Submitting author", "Title", "Presenting author","Abstract text","Abstract doc","Ethical clearance","Ethical clearance doc","Clinical trial registered","Abstract presentation","Previously presented","Created at","Authors");
        fputcsv($fp,$head);
        
        for ($i = 0; $i < count($jsonString); $i ++) {
           // print_r($jsonString[$i]);
           //get authors for abstract
          $author_data=$this->getAbstractAuthors($jsonString[$i]['id']);
        //   $authors=json_decode($author_data->content(), true);
        //   print_r($authors);
          $author="";
          for($x = 0; $x < count($author_data); $x ++) {
           //print_r($author_data[$x]->author_name);
           $author=$author.'['.$author_data[$x]->author_name.'|'.$author_data[$x]->author_affiliation.'|'.$author_data[$x]->author_email.']';
          }
          //decode json arry
          $jsonString2=$jsonString;
          $jsonString2[$i]["author"]=$author;
          
          
          
            $jsonString2[$i]['id'] = "CCPAB".strval($jsonString2[$i]['id']);
            fputcsv($fp, array_values($jsonString2[$i]));

            // for ($i = 0; $i < count($authorList); $i ++) {
            // //fputcsv($fp, array_values($authorList[$i]));
            // }
        }
        fclose($fp);
        return;
    }


public function removeFile(Request $request,$fileName){
    if(file_exists(public_path('files/'.$fileName))){
    unlink(public_path('files/'.$fileName));
    return response()->json("File deleted", 200); 
    }else{
    return response()->json("File does not exists.", 200);
    }
}

public function downloadDocs(Request $request){
    $this->search_text=$request->input('search_text');
    $this->search_from=$request->input('search_from');
    if($this->search_from=='id'){
        if(preg_match("/[a-z]/i", $this->search_text)){
            $this->search_text = preg_replace("/[^0-9]/", "", $request->input('search_text') );
        }
    }
    $data=DB::table('abstract_data')
    ->where('abstract_data.'.$this->search_from, 'like',  '%'.$this->search_text.'%')
    ->select('abstract_data.id','abstract_data.abstract_title','abstract_data.abstract_file','abstract_data.approval_letter_file')
    ->get();
    if(!$data->isEmpty()){
    //$date = date('Y-m-d H:i:s');
    $response=$this->download_attachment($data,"abstract_docs");
    if($response){
        return response()->json("Success", 200); 
    }else{
        return response()->json("No files found", 404); 
    }
    }else{
        // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
        return response()->json("No data", 404); 
    } 
}

public function download_attachment($data,$ticket_no)
{
    $zip = new \ZipArchive();
    $fileName = $ticket_no.'.zip';
    $imgarr=[];

    // delete temp file
    if(file_exists(public_path('files/abstract_zip_temp/'.$fileName))){
        unlink(public_path('files/abstract_zip_temp/'.$fileName));
        }

    foreach($data as $data){

        if(\File::exists(public_path('files/'.$data->abstract_file))){
        $imgarr[]= public_path('files/'.$data->abstract_file);
        }

    }


    if ($zip->open(public_path('files/abstract_zip_temp/'.$fileName), \ZipArchive::CREATE)== TRUE)
    {
        $files = $imgarr;
        foreach ($files as $key => $value){
            $relativeName = basename($value);
            $zip->addFile($value, $relativeName);
        }
        $zip->close();
    }

    // 
    if(file_exists(public_path('files/abstract_zip_temp/'.$fileName))){
        return true;
        }else{
        return false;
        }
    //return response()->download(public_path('files/abstract_zip_temp/'.$fileName));

}

}
