<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\Models\AbstractSubmission;
use App\Models\AbstractData;
use App\Models\AbstractAuthor;
use App\User;
use App\Notifications\SendConfirmEmail;
use Session;
use Response;
use DB;
use Auth;

class AbstractReviewController extends Controller
{
    public function index()
    {
        // if (!Session::has('name'))
        // {
        //     $sessionTimeout = 1;
        // }

        $abstractData = array(
            "submission_title"=>Session::get('submission_title'),
            "authors_data"=>Session::get('authors_data'),
            "abstract_text"=>Session::get('abstract_text'),
            "abstract_doc"=>Session::get('abstract_file'),
            "approval_letter_file"=>Session::get('approval_letter_file'),
            "presenting_author"=>Session::get('presenting_author'),
            "ethical_clearance"=>Session::get('ethical_clearance'),
            "clinical_trial_registered"=>Session::get('clinical_trial_registered'),
            "abstract_presentation"=>Session::get('abstract_presentation'),
            "previously_presented"=>Session::get('previously_presented')
        );
        //return view('abstract_review');
        return view('abstract_review', [
            'abstractData' => $abstractData
        ]);
    }

    public function store(Request $request)
    {
        $user=Auth::user();

        $data = ([
            "user_id"=>auth()->id(),
            "abstract_title"=>Session::get('submission_title'),
            "abstract_text"=>Session::get('abstract_text'),
            "abstract_file"=>Session::get('abstract_file'),
            
            "approval_letter_file"=>Session::get('approval_letter_file'),
            "presenting_author"=>Session::get('presenting_author'),
            "ethical_clearance"=>Session::get('ethical_clearance'),
            "clinical_trial_registered"=>Session::get('clinical_trial_registered'),
            "abstract_presentation"=>Session::get('abstract_presentation'),
            "previously_presented"=>Session::get('previously_presented')

        ]);
        $responsedata = AbstractData::create($data);

        // storing author data
        $author_data=Session::get('authors_data');
        if(isset($author_data) && !empty(Session::get('authors_data')) ){
            
        foreach($author_data as $key => $value) {
         //print_r($value);
            $author_data = ([
                "abstract_data_id"=>$responsedata['id'],
                "author_name"=>$value["author_name"],
                "author_affiliation"=>$value["affiliation"],
                "author_email"=>$value["author_email"]
            ]);
            $responsedataAuthor = AbstractAuthor::create($author_data);
        }   
    }

    //renaming_abstract_files_if_exist

    $ab_filename = public_path('files/').Session::get('abstract_file');
    $new_ab_filename=public_path('files/').'CCPAB'.$responsedata['id'].'_'.Session::get('abstract_file');
    if (file_exists($ab_filename) && is_file($ab_filename)) {
       // echo "The file $filename exists";
       rename($ab_filename , $new_ab_filename);
       // update file name in database
       DB::table('abstract_data')
       ->where('id', $responsedata['id'])
       ->update(['abstract_file' => 'CCPAB'.$responsedata['id'].'_'.Session::get('abstract_file')]);

    }else{
        //echo("no files");
    }
 
    // rename ethis file if exist
    $et_filename = public_path('files/').Session::get('approval_letter_file');
    $new_et_filename=public_path('files/').'CCPAB'.$responsedata['id'].'_'.Session::get('approval_letter_file');
    if (file_exists($et_filename) && is_file($et_filename)) {
       // echo "The file $filename exists";
       rename($et_filename , $new_et_filename);
       // update file name in database
       DB::table('abstract_data')
       ->where('id', $responsedata['id'])
       ->update(['approval_letter_file' => 'CCPAB'.$responsedata['id'].'_'.Session::get('approval_letter_file')]);

    }else{
        //echo("no files ethics");
    }

    //renaming_abstract_ethics_files_if_exist
     
    if($responsedata){
        $user->notify(new SendConfirmEmail($responsedata['id'],$responsedata['abstract_title']));
    }
        // print_r($responsedata['id']);
        return Response::json($responsedata);
}

}