<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\Http\Controllers\AbstractPortalController;
use App\Models\User;
use App\Models\AbstractSubmission;
use App\Models\abstract_affiliation;
use App\Models\AbstractData;

use Illuminate\Support\Facades\DB;
use Session;
use Auth;
use Response;

class AbstractSubmissionController extends Controller
{
    public function index(Request $request,$returnPath)
    {

        $user_id=Auth::user()->id;
        $data = DB::table('abstract_submissions')
        ->where('user_id', '=', $user_id)
        ->get();
        $recoredcount = AbstractData::where('status','=','1')->where('user_id', Auth::user()->id)->count();
       //print_r($recoredcount);
        if(isset($data[0])){
          $abstract=$data[0];
          return redirect('/'.$returnPath);
        }else{
          return view('abstract_submition')->with(compact('returnPath'));
        }
        
    }

    public function viewAbstract(){
        $user_id=Auth::user()->id;
        $data = DB::table('abstract_submissions')
        ->where('user_id', '=', $user_id)
        ->get();
        $recoredcount = AbstractData::where('status','=','1')->where('user_id', Auth::user()->id)->count();
       //print_r($recoredcount);
        if(isset($data[0])){
          $abstract=$data[0];
          return view('dashboard-abstract')->with(compact('abstract','recoredcount'));
        }else{
          // echo(Auth::user()->id);
          return view('dashboard-abstract')->with(compact('recoredcount'));
        }   
    }

    public function get(){
        $user_id=Auth::user()->id;
        $data = DB::table('abstract_submissions')
        ->where('user_id', '=', $user_id)
        ->get();
        if(isset($data[0])){
            return Response::json($data[0]);
        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }
    }

    public function editProfile(){
        $abstract="";
        $user_id=Auth::user()->id;
        $data = DB::table('abstract_submissions')
        ->where('user_id', '=', $user_id)
        ->get();
        if(isset($data[0])){
            $abstract=$data[0];
            return view('abstract_submition_edit')->with(compact('abstract'));
            //return Response::json($abstract);
        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }  
    }

    public function get_by_id(Request $request){
        $id=$request->input('id');
        $data = DB::table('abstract_submissions')
        ->where('id', '=', $id)
        ->get();
        if(isset($data[0])){
            return Response::json($data[0]);
        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }
    }


    public function getAll(Request $request){
        $search_text=$request->input('search_text');
        $search_from=$request->input('search_from');

        $data = DB::table('abstract_submissions')
        ->where($search_from, 'like', $search_text.'%')
        ->orderBy('id', 'desc')
        ->get();
        if(isset($data)){
            return Response::json($data);
        }else{
            // return response()->json(['success'=>'You have successfully upload file.','file_name'=>$fileName]);
            return response()->json("No data", 404); 
        }
    }
  
    public function submit(Request $request){

    try{   
        // $validator = Validator::make($request->all(), [
        //     'title' => 'required|string|max:255',
        //     'given_name' => 'required|max:255',
        //     'surename' => 'required|max:255',
        //     'name_with_initials' => 'required|max:255',
        //     'designation' => 'required|max:255',
        //     'address' => 'required|max:255',
        //     'telephone_number' => 'required|max:255',
        //     'mobile_number' => 'required|max:255',  
        //     'email' =>'required|email'
        // ]);
        $request->validate([
            'title' => 'required|string|max:255',
            'given_name' => 'required|max:255',
            'surename' => 'required|max:255',
            'name_with_initials' => 'required|max:255',
            'designation' => 'required|max:255',
            'address' => 'required|max:255',
            'telephone_number' => 'required|max:255',
            'mobile_number' => 'required|max:255',  
            'email' =>'required|email'
        ]);
    } catch (\Illuminate\Validation\ValidationException $th) {
        // return $th->validator->errors();
        return Response::json($th->validator->errors(),400);
    }
        // if ($validator->fails()) {
        //     // return redirect()->back()
        //     //     ->withErrors($validator)
        //     //     ->withInput();
        //     //     return Response::json($responsedata);
        //     return $th->validator->errors();
        // }
        
        $type_of_presentation="";
        if($request->input('oral_present')!=""){
            $type_of_presentation=$request->input('oral_present');
        }
        if($request->input('poster_present')!=""){
            $type_of_presentation=$request->input('poster_present');
        }

        $data = ([
            "user_id"=>auth()->id(),
            "title"=>$request->input('title'),
            "given_name"=>$request->input('given_name'),
            "surname"=>$request->input('surename'),
            "name_with_initials"=>$request->input('name_with_initials'),
            "designation"=>$request->input('designation'),
            "address"=>$request->input('address'),
            "telephone_number"=>$request->input('telephone_number'),
            "mobile_number"=>$request->input('mobile_number'),
            "email"=>$request->input('email'),
            "type_of_presentation"=>$type_of_presentation
        ]);
        $responsedata = AbstractSubmission::create($data);

        // storing affiliation data
        $affiliation_data=$request->input('affiliation_data');
        if(isset($affiliation_data) && !empty($request->input('affiliation_data')) ){
            
        
        foreach($affiliation_data as $key => $value) {
         //print_r($value);
            $affiliation_data = ([
                "abstract_submissions_id"=>$responsedata['id'],
                "affiliation_name"=>$value["affiliation_name"]
            ]);
            $responsedataAffiliation = abstract_affiliation::create($affiliation_data);
        }

        
        // print_r($responsedata);
        //return redirect()->back()->withSuccess('Successfully created!');
    }
    return Response::json($responsedata);
    }

    
    public function update(Request $request, $id){
        $validator = Validator::make($request->all(), [
            'title' => 'required|string|max:255',
            'given_name' => 'required|max:255',
            'surename' => 'required|max:255',
            'name_with_initials' => 'required|max:255',
            'designation' => 'required|max:255',
            'address' => 'required|max:255',
            'telephone_number' => 'required|max:255',
            'mobile_number' => 'required|max:255',  
            'email' =>'required|email'
        ]);
        if ($validator->fails()) {
            return redirect()->back()
                ->withErrors($validator)
                ->withInput();
        }
    
    
        $type_of_presentation="";
        if($request->input('oral_present')!=""){
            $type_of_presentation=$request->input('oral_present');
        }
        if($request->input('poster_present')!=""){
            $type_of_presentation=$request->input('poster_present');
        }

        $item = AbstractSubmission::find($id);
        $item->title = $request->input('title');
        $item->given_name = $request->input('given_name');
        $item->surname = $request->input('surename');
        $item->type_of_presentation = $type_of_presentation;
        $item->name_with_initials = $request->input('name_with_initials');
        $item->designation = $request->input('designation');
        $item->address = $request->input('address');
        $item->telephone_number = $request->input('telephone_number');
        $item->mobile_number = $request->input('mobile_number');

        $item->save();

        // $response=response()->json(['success' => 'success'], 200);
        // return view('abstract_submition_edit')->with($response);
        return redirect()->back()->withSuccess('Successfully updated');
        
    }
}
