<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Response;
use Illuminate\Support\Facades\Route;
use App\Models\courses;
use App\Models\courseCategory;



class CoursesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     */
    public function index()
    {

        //echo($action);
        //$courses = courses::all();
        $courses = courses::all()->sortByDesc("id")->where('status', '=', 1);
        $categorys = courseCategory::all();
        return view('courses')->with(compact('courses','categorys'));
    }
    /**
     * Store a newly created resource in storage.
     *
     */
    public function store(Request $request)
    {
        $data = $request->validate([
            'courseName'  => 'required|max:255',
            'description' => 'required',
            'price'       => 'required',
            'currency'    => 'required',
            'participantsLimit'=>'required',
            'category_id'=>'required'
        ]);
        $coursesdata = courses::create($data);
        return Response::json($coursesdata);
    }

    public function edit($id){
        $item = courses::find($id);
        return Response::json($item);
    }

    public function update(Request $request, $id)
    {
        $item = courses::find($id);
        $item->courseName = $request->input('courseName');
        $item->description = $request->input('description');
        $item->price = $request->input('price');
        $item->currency = $request->input('currency');
        $item->participantsLimit = $request->input('participantsLimit');
        $item->category_id = $request->input('category_id');

        $item->save();
        return response()->json("ok", 200); 
    }

    public function delete(Request $request){
        $item = courses::find($request->input('id'));
        $item->status = 9;

        $item->save();   
        return response()->json("ok", 200); 
    }
}
