<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('courses', function (Blueprint $table) {
            $table->id();
            $table->string('courseName');
            $table->string('description');
            $table->float('price',8,2);
            $table->integer('articipantsLimit');
            $table->dateTime('createdAt', $precision = 0)->nullable();
            $table->integer('createdBy')->nullable();
            $table->dateTime('updatedAt', $precision = 0)->nullable();
            $table->dateTime('deletedAt', $precision = 0)->nullable();
            $table->integer('lastUpdateBy')->nullable();
            $table->integer('status')->default(1);
            $table->timestamps();
        });
    }
        /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('courses');
    }
};
