jQuery(document).ready(function($){
    //----- Open model CREATE -----//
    let word_limit_exeeded=false;
    jQuery('#btn-add').click(function () {
        jQuery('#formModal').modal('show');
        $("#data_validation_response").html("");
    });

    // adding new author
    let jsonObject = [];
    let a_key=0;
    let abstract_file_name;
    let approval_letter_file;
    jQuery('#btn-add-auth').click(function () {
        jQuery("#authors_table").html("");
        $("#data_validation_response").html("");
        jQuery("#authors_table").append("<tr><th></th><th>Name</th><th>Affiliation</th><th>Email address</th><th></th></tr>");

        name_wt_initials  = jQuery("#name_wt_initials").val();
        affiliation       = jQuery("#affiliation").val();
        author_email      = jQuery("#author_email").val();

        // validating fields
        // check auther name
        if(name_wt_initials == ""){
            $("#data_validation_response").html("<div class='alert alert-warning' role='alert'>Name with initials cannot be empty !</div>");
            return;
        }

        if(affiliation == ""){
            $("#data_validation_response").html("<div class='alert alert-warning' role='alert'>Affiliation cannot be empty !</div>");
            return;
        }
        if(author_email == ""){
            $("#data_validation_response").html("<div class='alert alert-warning' role='alert'>Email address cannot be empty !</div>");
            return;
        }

        // validating email
        if(author_email != ""){
            if(!isEmail(author_email)){
                $("#data_validation_response").html("<div class='alert alert-warning' role='alert'>please enter a valid email address !</div>");
                return;
            }
        }

        jsonObject.push({
            author_name: name_wt_initials,
            affiliation:affiliation,
            author_email : author_email
        });

        let count=0;
        for (var key in jsonObject) {
            let index_c=+key + +1;
            count=+count + +1;
            console.log(jsonObject[key].author_name);
            jQuery("#authors_table").append("<tr><td>"+count+"</td><td>"+jsonObject[key].author_name+"</td><td>"+jsonObject[key].affiliation+"</td><td>"+jsonObject[key].author_email+"</td><td><button type='button' data-id="+key+" class='btn btn-primary btn-sm btn_remove'>Remove</button></td></tr>");
            //jQuery("#authors_table").append("<tr><td>1</td><td><b>Name with initials : </b>"+jsonObject[key].author_name+"</td><td><b>Affiliation : </b>"+jsonObject[key].affiliation+"</td><td><b>Email : </b>"+jsonObject[key].author_email+"</td><td>Remove</td></tr>");
        }
        
        jQuery('#formModal').modal('hide');
    });

// email validation
function isEmail(email) {
    var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
    return regex.test(email);
  }

// remove item
$('#authors_table').on('click', '.btn_remove', function(e) {
    jQuery("#authors_table").html("");
    jQuery("#authors_table").append("<tr><th></th><th>Name</th><th>Affiliation</th><th>Email address</th><th></th></tr>");
    id=$(this).attr("data-id");

    //console.log(id);
    delete jsonObject[id];
    //console.log(jsonObject);
    let count=0;
    for (var key in jsonObject) {
        let index_c=+key + +1;
        count=+count + +1;
        jQuery("#authors_table").append("<tr><td>"+count+"</td><td>"+jsonObject[key].author_name+"</td><td>"+jsonObject[key].affiliation+"</td><td>"+jsonObject[key].author_email+"</td><td><button type='button' data-id="+key+"  class='btn btn-primary btn-sm btn_remove'>Remove</button></td></tr>");
    }
}); 

    jQuery('#submit_btn').click(function (e) {
        if(word_limit_exeeded==true){
            jQuery("#responses").append("<div class='alert alert-warning' role='alert'>Your abstract text word limit exceeded.</div>");
            return false;
        }else{
        $("#responses").html("");
        var formData = {
            submission_title: jQuery('#submission_title').val(),
            author_data     : jsonObject,
            presenting_author:jQuery('#presenting_author').val(),
            abstract_text:jQuery('#abstract_text').val(),
            abstract_file:abstract_file_name,
            ethical_clearance:jQuery('#ethical_clearance').val(),
            approval_letter_file:approval_letter_file,
            clinical_trial_registered:jQuery('#clinical_trial_registered').val(),
            abstract_presentation:jQuery('#abstract_presentation').val(),
            previously_presented:jQuery('#previously_presented').val(),
            word_count:jQuery('#word_count').val()
        };
        var base_url=$("#base_url").val();
        var type = "POST";
        var ajaxurl = base_url+'/abstractPortal/submit';
        e.preventDefault();
        $.ajax({
            type: type,
            url: ajaxurl,
            data: formData,
            dataType: 'json',
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            beforeSend: function() {
                $("#spinner").html("<div class='spinner-border text-primary' role='status'><span class='sr-only'>Loading...</span></div>");          
            },
            success: function (data) {
                 window.location.replace(base_url+"/abstractReview");
            },
            error: function (data) {
                $("#spinner").html("");
                $(window).scrollTop(0);
                //console.log(data.responseText);
                try {
                    var obj = JSON.parse(data.responseText);
                    for (var key in obj) {
                      console.log(obj[key][0]);
                      jQuery("#responses").append("<div class='alert alert-warning' role='alert'>"+obj[key][0]+"</div>");
                    }
                  } catch (e) {
                    // properly handle the error when the input is not a valid JSON string
                
                  }

            }
        });
     }
    });
    // file uploader
    $('#fileUploadForm').ajaxForm({
        
        beforeSend: function (xhr, opts) {
            $(".progress1").show();
            $('.progress-bar1').css('width', '0%').attr('aria-valuenow', 0); 
            $("#file_response").html("");
            file=$("#file_ab").val();
            if(file==""){
                console.log("no file");
                $("#file_response").html("<div class='alert alert-warning' role='alert'>Please choose a file to upload!</div>");
                xhr.abort();
            }

            var percentage = '0';

        },

        uploadProgress: function (event, position, total, percentComplete) {

            var percentage = percentComplete;

            $('.progress1 .progress-bar1').css("width", percentage+'%', function() {

              return $(this).attr("aria-valuenow", percentage) + "%";

            })
            

        },
        
        success: function (xhr) {
            console.log(xhr);
            //var obj = JSON.parse(xhr);
            abstract_file_name=xhr.file_name;
            //console.log(obj.file_name);
            $(".progress1").hide();
            $("#file_response").html("<div class='alert alert-info' role='alert'>You have successfully upload file<input style='margin-left:5px' type='button' class='btn btn-warning' id='remove_file' data-id='"+abstract_file_name+"' value='Remove file'></div>");

        },
        error: function(xhr){
            var obj2=JSON.parse(xhr.responseText);
            console.log(obj2.message);
            $("#file_response").html("<div class='alert alert-warning' role='alert'>"+obj2.message+"</div>");
        }

    });

    // file uploader2
    $('#fileUploadForm2').ajaxForm({

        beforeSend: function (xhr, opts) {
            $(".progress2").show();
            $('.progress-bar2').css('width', '0%').attr('aria-valuenow', 0); 

            file=$("#file_ethics").val();
            if(file==""){
                console.log("no file");
                $("#file_response2").html("<div class='alert alert-warning' role='alert'>Please choose a file to upload!</div>");
                xhr.abort();
            }
            var percentage = '0';

        },

        uploadProgress: function (event, position, total, percentComplete) {

            var percentage = percentComplete;

            $('.progress2 .progress-bar2').css("width", percentage+'%', function() {

              return $(this).attr("aria-valuenow", percentage) + "%";

            })

        },
        success: function (xhr) {
            //var obj = JSON.parse(xhr.responseText);
            approval_letter_file=xhr.file_name;
            console.log('File has uploaded');
            $(".progress2").hide();
            $("#file_response2").html("<div class='alert alert-info' role='alert'>You have successfully upload file<input style='margin-left:5px' type='button' class='btn btn-warning' id='remove_file2' data-id='"+approval_letter_file+"' value='Remove file'></div>");

        },
        error: function(xhr){
            var obj2=JSON.parse(xhr.responseText);
            console.log(obj2.message);
            $("#file_response").html("<div class='alert alert-warning' role='alert'>"+obj2.message+"</div>");
        }

    });

    jQuery("#abstract_text").on('paste keyup', function(e) {
        var words = $.trim(this.value).length ? this.value.match(/\S+/g).length : 0;
        if (words <= 250) {
            let word_limit_exeeded=false;
            $("#limit_exeed").html('');
            $('#display_count').text(words);
            $('#word_left').text(250-words);
            $('#word_count').val(words);
        }else{
            $('#display_count').text(words);
            $('#word_count').val(words);
            $('#word_left').text("0");
            let word_limit_exeeded=true;
            $("#limit_exeed").html('Word limit exceeded !');
            console.log("word limit exceed");
        }
    });

    $('#file_ab').on( 'change', function() {
        $("#file_response").html("");
        myfile= $( this ).val();
        var ext = myfile.split('.').pop();
        if(ext=="docx" || ext=="doc"){
        } else{
            $("#file_ab").val(null);
            $("#file_response").html("<div class='alert alert-warning' role='alert'>Please select only doc/docx file to upload</div>");
        }
     });

     $('#file_ethics').on( 'change', function() {
        $("#file_response2").html("");
        myfile= $( this ).val();
        var ext = myfile.split('.').pop();
        if(ext=="docx" || ext=="doc" || ext=="pdf" || ext=="jpg" || ext=="jpeg" || ext=="png"){
        } else{
            $("#file_ethics").val(null);
            $("#file_response2").html("<div class='alert alert-warning' role='alert'>Please select only doc/docx/pdf or an image file to upload</div>");
        }
        console.log($("#file_ethics")[0].files[0].size);
          if($("#file_ethics")[0].files[0].size > 1000000) {
            $("#file_response2").html("<div class='alert alert-warning' role='alert'>Please upload a file less than 1MB</div>");
            $("#file_ethics").val(null);
          }
     });
  
     $('#file_response').on('click', '#remove_file', function(e) {
        fileName=$(this).attr('data-id')
        var base_url=$("#base_url").val();
        $.ajax({
            url : base_url+'/abstractPortal/removeFile/'+fileName,
            type : 'GET',
            dataType:'json',
            success : function(data) {              
                $("#file_response").html("<div class='alert alert-info' role='alert'>File Deleted</div>");
                $("#file_ab").val(null);
            },
            error : function(request,error)
            {
                //alert("Request: "+JSON.stringify(request));
            }
        });  
     });

     $('#file_response2').on('click', '#remove_file2', function(e) {
        fileName=$(this).attr('data-id')
        var base_url=$("#base_url").val();
        $.ajax({
            url : base_url+'/abstractPortal/removeFile/'+fileName,
            type : 'GET',
            dataType:'json',
            success : function(data) {              
                $("#file_response2").html("<div class='alert alert-info' role='alert'>File Deleted</div>");
                $("#file_ethics").val(null);
            },
            error : function(request,error)
            {
                //alert("Request: "+JSON.stringify(request));
            }
        });  
     });
});
